#include <RobotMonet.h>
RobotMonet::RobotMonet()
{
	
	   m_entreAxe=0;
	   m_diametreRoue=0;
	   m_distance4Secondes=0;
	   m_vitesse_droit=0;
	   m_vitesse_gauche=0;
	
	
}
  void  RobotMonet::Init( float entraxe, float diametre, float distance4s, byte vitesse_droit, byte vitesse_gauche )
  {
	   m_entreAxe=entraxe;
	   m_diametreRoue=diametre;
	   m_distance4Secondes=distance4s;
	   m_vitesse_droit=vitesse_droit;
	   m_vitesse_gauche=vitesse_gauche;
	   this->Attache();
  };
void RobotMonet::Attache()
{
	pinMode(TRIGPIN, OUTPUT);  			//Trig est une sortie
	pinMode(ECHOPIN, INPUT);   			//Echo est le retour, en entrée
	pinMode(CAPTEURDROIT, INPUT); 		//capteur 
	pinMode(CAPTEURGAUCHE, INPUT);
	//Définit les sorties pour le pont en H
	pinMode(AIA, OUTPUT); // set pins to output
	pinMode(AIB, OUTPUT);
	pinMode(BIA, OUTPUT);
	pinMode(BIB, OUTPUT);
	m_servo.attach(SERV);
	#ifdef _DEBUG
	Serial.begin(9600);
	#endif
	VitesseN=this->CalculVitesseN();
	
}
void RobotMonet::VaToutDroit()
{
  analogWrite(AIA, 0);
  analogWrite(AIB, m_vitesse_droit);
 analogWrite(BIA, 0);
  analogWrite(BIB, m_vitesse_gauche);
}
void RobotMonet::VaToutDroit(unsigned int distance)
{
	unsigned long temps_arrivee=(unsigned long)this->CalculTpsAvance(distance);
	#ifdef _DEBUG	
	Serial.println("36 temps_arrivee");
	 Serial.println(temps_arrivee);
	 Serial.println("38 distance");
	 Serial.println(distance);
	 #endif
	this->VaToutDroit();
	delay(temps_arrivee);
	this->Stop();
}

void RobotMonet::VaEnArriere()
{
  analogWrite(AIA, m_vitesse_droit);
  analogWrite(AIB, 0);
  analogWrite(BIA, m_vitesse_gauche);
  analogWrite(BIB, 0);
}
void RobotMonet::VaEnArriere(unsigned int distance)
{
	unsigned long temps_arrivee=this->CalculTpsAvance(distance);
	delay(200);
	this->VaEnArriere();
	delay(temps_arrivee);
	this->Stop();
	delay(200);
}

void RobotMonet::Stop()
{
  analogWrite(AIA, 0);
  analogWrite(AIB, 0);
  analogWrite(BIA, 0);
  analogWrite(BIB, 0);

}

void RobotMonet::VajusquaLigne()
{
	bool b_Est_Sur_Ligne;
	b_Est_Sur_Ligne=false;
	this->VaToutDroit();
	while (!(this->DetecteurGaucheSurLigne() || this->DetecteurDroitSurLigne()))
	{
		delay(50);
	}
	this->Stop();
}
bool RobotMonet::VajusquaLigne(unsigned int distance)
{
	bool b_Est_Sur_Ligne;
	unsigned long temps_arrivee=this->CalculTpsAvance(distance);
	unsigned int nb_Iterations=temps_arrivee/50;
	
	#ifdef _DEBUG	
	Serial.println("va jusqu'a ligne"); 
	Serial.println("84 temps jusqu'a la paroi");   
	Serial.println(temps_arrivee);  
	delay(2000);
	Serial.println("88 nbitération");   
	Serial.println(nb_Iterations);  
	delay(2000);
	#endif
	unsigned int i=0;
	b_Est_Sur_Ligne=true;
	this->VaToutDroit();
	while (!(this->DetecteurGaucheSurLigne() || this->DetecteurDroitSurLigne()) && (i<nb_Iterations))
	{
		i++;
		delay(50);
	}
	Serial.println("stop"); //il a trouvé la ligne
	this->Stop();
	if (i==nb_Iterations)
	{
		b_Est_Sur_Ligne=false;
		
	}
	Serial.println(b_Est_Sur_Ligne);
	delay(100);
	return b_Est_Sur_Ligne; 
}

unsigned int  RobotMonet::CalculDistance()
{
 long duration, distance;
  digitalWrite(TRIGPIN, LOW);  
  delayMicroseconds(2); 
  digitalWrite(TRIGPIN, HIGH);
  delayMicroseconds(10); //Trig déclenché 10ms sur HIGH
  digitalWrite(TRIGPIN, LOW);
  
  // Calcul de l'écho
  duration = pulseIn(ECHOPIN, HIGH);
  // Distance proportionnelle à la durée de sortie
  distance = duration*340/(2*10000);  //Vitesse du son théorique
	#ifdef _DEBUG
	Serial.println("122 la distance");
	Serial.println(distance);
	#endif
  return (unsigned int)distance;
  
 }
 
 void RobotMonet::TourneAGauche()
 {
		analogWrite(AIA, 0);
		analogWrite(AIB, m_vitesse_droit);
		analogWrite(BIA, 0);
		analogWrite(BIB, 0);
	
 }
 
  void RobotMonet::TourneADroite()
 {
		analogWrite(AIA, 0);
		analogWrite(AIB, 0);
		analogWrite(BIA, 0);
		analogWrite(BIB, m_vitesse_gauche);
 }
 
 void RobotMonet::TourneADroite(int angle)
 {
	this->TourneADroite();
	delay(CalculTpsTourne(angle));
	this->Stop();
 }
 
  void RobotMonet::TourneAGauche(int angle)
 {
	this->TourneAGauche();
	delay(CalculTpsTourne(angle));
	this->Stop();
	

 }
   void RobotMonet::TourneADroiteCourt()
   {
	    analogWrite(AIA, m_vitesse_droit);
		analogWrite(AIB, 0);
		analogWrite(BIA, 0);
		analogWrite(BIB, m_vitesse_gauche);
   }
  void RobotMonet::TourneAGaucheCourt()

  {
		analogWrite(AIA, 0);
		analogWrite(AIB, m_vitesse_droit);
		analogWrite(BIA, m_vitesse_gauche);
		analogWrite(BIB, 0);
  }  
  void RobotMonet::TourneCourtADroite(int angle)  //Tourne court à droite suivant l'angle défini
  {
		long le_temps= CalculTpsTourne(angle)/2;
		this->TourneADroiteCourt();
		delay(le_temps);
		this->Stop();
  }
  
  void RobotMonet::TourneCourtAGauche(int angle)	
  {
	  	long le_temps= CalculTpsTourne(angle)/2;
		this->TourneAGaucheCourt();
		delay(le_temps);
		this->Stop();
  }
  void RobotMonet::TourneCourt(int angle)
   {	   
	  if (angle>0)
	  {
			this->TourneADroiteCourt(angle);			
	  }
	  else 
	  {
			this->TourneAGaucheCourt(-angle);
	  }
   }
  void RobotMonet::Tourne(int angle) //Tourne le robot (-90 à droite  0 droit devant, 90 à gauche)
  {
	  if (angle>0)
	  {
			this->TourneADroite(angle);
	  }
	  else 
	  {
		  this->TourneAGauche(-angle);
	  }
  }  
  

 float RobotMonet::CalculVitesseN()
 {
	 float ret_vitesse;
	 ret_vitesse=this->m_distance4Secondes/(4*m_diametreRoue*pi);
	 #ifdef _DEBUG
	 Serial.println("Calcul vitesse");
	 Serial.println(ret_vitesse);
	 #endif
	 ret_vitesse=ret_vitesse*0.85;	 
	return (ret_vitesse);
 }
  unsigned long RobotMonet::CalculTpsTourne(int degres)

 {
	 float  ret_tmps;
	 degres=abs(degres);
	 ret_tmps=((degres*m_entreAxe)/(180*VitesseN*m_diametreRoue));
	 ret_tmps=ret_tmps*1000;
	 #ifdef _DEBUG
	 Serial.println("degres");
	 Serial.println(degres);
	 Serial.println("m_entreAxe");
	 Serial.println(m_entreAxe);
	 Serial.println("VitesseN");
	 Serial.println(VitesseN);
	 Serial.println("m_diametreRoue");
	 Serial.println(m_diametreRoue);
	 Serial.println("Calcul temps tourne");
	 Serial.println(ret_tmps);
	 #endif
	 return (unsigned long)ret_tmps+this->m_Latence;
 }
  unsigned long RobotMonet::CalculTpsAvance(unsigned int distance)

 {
	 
	 float ret_tmps;
	 
	 ret_tmps=((distance)/(pi*VitesseN*m_diametreRoue));
	 ret_tmps=ret_tmps*1000;

	 #ifdef _DEBUG
	 Serial.println("246 distance");
	 Serial.println(distance);
	 Serial.println("VitesseN");
	 Serial.println(VitesseN);
	 Serial.println("m_diametreRoue");
	 Serial.println(m_diametreRoue);
	 Serial.println("Calcul temps tourne");
	 
	 Serial.println(ret_tmps);
	 Serial.println("ret_tmps_long");
	 Serial.println(ret_tmps_long);
	 #endif
	 return (unsigned long)ret_tmps+this->m_Latence;
 }
   bool RobotMonet::DetecteurDroitSurLigne()
   {
		bool retValue;
		retValue=digitalRead(CAPTEURDROIT);
		return retValue;
   }
  bool RobotMonet::DetecteurGaucheSurLigne()
  {
		bool retValue;
		retValue=digitalRead(CAPTEURGAUCHE);
		return retValue;
  }
  
  void RobotMonet::Regarde(int angle)
  {
	m_servo.write(angle+90);
	delay(100);
	
  }
 
  
  
  
  
   unsigned int RobotMonet::TrouveDistanceParoiPlusProche(unsigned int distance_mini, int angle_mini, int angle_maxi)
   {

	   return this->TrouveParoiPlusProche(distance_mini,angle_mini,angle_maxi).m_distance;
   }
   unsigned int RobotMonet::TrouveDistanceParoiPlusLoin(unsigned int distance_mini, int angle_mini, int angle_maxi)
   {
	   	  return this->TrouveParoiPlusLoin(distance_mini,angle_mini,angle_maxi).m_distance;
   }
   int RobotMonet::TrouveAngleParoiPlusProche(unsigned int distance_mini, int angle_mini, int angle_maxi)
   {
	   	  return this->TrouveParoiPlusProche(distance_mini,angle_mini,angle_maxi).m_angle;
   }
      int RobotMonet::TrouveAngleParoiPlusLoin(unsigned int distance_mini, int angle_mini, int angle_maxi)
   {
	   	  return this->TrouveParoiPlusLoin(distance_mini,angle_mini,angle_maxi).m_angle;
   }
   CParoi RobotMonet::TrouveParoiPlusProche(unsigned int distance_mini, int angle_mini, int angle_maxi)
  {
	  CTableau LeTabParoi(38);
	  CParoi laparoi;
	  unsigned int ret_val;

	  unsigned int distance_plus_proche=1000;
	  laparoi.m_distance=1000;
	  unsigned int j=0;
	  unsigned int index_min;
	  this->Regarde(angle_mini);
			delay(500);
		for (int i=angle_mini ; i<=angle_maxi;  i=i+5)
		{
			this->Regarde(i);
			//delay(500);
			ret_val=this->CalculDistance();
			
			if (ret_val<distance_plus_proche && ret_val>distance_mini)
			{
	
					index_min=j;
					distance_plus_proche=ret_val;

			}
			laparoi.m_angle=i;
			laparoi.m_distance=ret_val;
			LeTabParoi.SetTab(j, laparoi);
				//Serial.println(i);
				j++;
				//Serial.print(" ");					
			//	Serial.println(ret_val);
				
		}
				//				Serial.println("distance_mini");
				//	Serial.println(distance_plus_proche);
				//	Serial.println("index_ref");
				//	Serial.println(index_min);
				
		laparoi.m_angle=(int)this->ChercheAngleMoyen(LeTabParoi,index_min);
		laparoi.m_distance=LeTabParoi.GetTab(index_min).m_distance;
		#ifdef _DEBUG
		Serial.println("retour angle");
		Serial.println(laparoi.m_angle);
		Serial.println("retour distance");
		Serial.println(laparoi.m_distance);
		#endif
		this->Regarde(0);
		return laparoi;
  }
   float RobotMonet::ChercheAngleMoyen(CTableau& LeTab, unsigned int index )
   {
	   unsigned int index_min=0;
	   int index_max=-1;
	   float langle=0;
	   //on cherche l'angle min à - 2cm
	  // Serial.println("index");
	//   Serial.println(index);
	   for (int i=index; i>=0; i--)
	   {
		 //   Serial.println("i min");
		//	Serial.println(i);
		   if ((LeTab.GetTab(i).m_distance-2)>LeTab.GetTab(index).m_distance) 
		   {
			   index_min=i+1;
			//   Serial.println("382 index_min");
			   i=0;
			//   Serial.println(index_min);
		   }
//  		Serial.println(i);

	
	   }
	   for (int i=index; i<LeTab.m_nb_elements; i++)
	   {
		//	Serial.println("i max");
		//	Serial.println(i);

			if (LeTab.GetTab(i).m_distance==0 &&LeTab.GetTab(i).m_angle==0&& index_max==-1)
			{
				index_max=i-1;
				//Serial.println("index_max 1");
			    //Serial.println(index_max);
				i=LeTab.m_nb_elements;
			}
		   else if ((LeTab.GetTab(i).m_distance-2)>(LeTab.GetTab(index).m_distance))
		   {
			   index_max=i-1;
			   Serial.println("index_max 2");
			   i=LeTab.m_nb_elements;
			   Serial.println(index_max);
		   }
	   }
	   //Serial.println("index min");
		//Serial.println(index_min);
		
	//	Serial.println("index max");
	//	Serial.println(index_max);
	   langle=LeTab.GetTab(index_max).m_angle-LeTab.GetTab(index_min).m_angle;
	//   Serial.println("langle1");
	//	Serial.println(langle);
	   langle=langle/2;
	   langle=langle+LeTab.GetTab(index_min).m_angle;
	   #ifdef _DEBUG
	   Serial.println(langle);
	   #end
	   return langle;
	   
   }
   CParoi RobotMonet::TrouveParoiPlusLoin(unsigned int distance_maxi, int angle_mini, int angle_maxi)
  {
	  CParoi la_Paroi;
	  unsigned int ret_val;

		this->Regarde(angle_mini);
		delay(500);
		for (int i=angle_mini ; i<=angle_maxi;  i=i+5)
		{
			this->Regarde(i);

			ret_val=this->CalculDistance();

			if (ret_val>la_Paroi.m_distance && ret_val<distance_maxi)
			{
					la_Paroi.m_angle=i;
					la_Paroi.m_distance=ret_val;	
					#ifdef _DEBUG
					Serial.println("retour angle");
					Serial.println(la_Paroi.m_angle);
					Serial.println("retour distance");
					Serial.println(la_Paroi.m_distance);
					delay(500);
					#endif					
										
			}
		}
			
		
		this->Regarde(0);
		return la_Paroi;
  }
  
    bool RobotMonet::VaToutDroitJusquaLimite(unsigned int adistance) //retourne true s'il a trouvé la ligne
	{
		int angle;
		bool retvalue=false;
		int LaDistanceReste;
		int LaDistanceParoi;
		CParoi la_Paroi;
		
		la_Paroi=this->TrouveParoiPlusProche(0, -30, 30);
		this->Tourne(la_Paroi.m_angle);

		LaDistanceParoi=la_Paroi.m_distance;
		LaDistanceParoi=LaDistanceParoi-adistance;
		#ifdef _DEBUG
		Serial.println("353 distance jus'a paroi");   
		Serial.println(LaDistanceParoi);
		#endif
		if (LaDistanceParoi<0)
		{
			this->VaEnArriere(abs(LaDistanceParoi));
			return false;
		}
		
 		

		//delay(2000);
		
		if (this->VajusquaLigne(LaDistanceParoi)==false)
		{
//s'il n'a pastrouvé la ligne, il rescane 
			la_Paroi=this->TrouveParoiPlusProche(0, -20, 20);
			this->Tourne(la_Paroi.m_angle);			
			LaDistanceReste=la_Paroi.m_distance;
			LaDistanceReste=LaDistanceReste-adistance;
			#ifdef _DEBUG
			Serial.println("402 distance arret");   
			Serial.println(adistance);  
			
			Serial.println("402 reste paroi");   
			Serial.println(LaDistanceReste);   
		//	delay(4000);
			#endif
			//et s'ajuste
			if (LaDistanceReste>0)
			{
				this->VaToutDroit(LaDistanceReste);
			}
			else
			{
				this->VaEnArriere(abs(LaDistanceReste));
			}
			return false;
		}
		delay(100);
		#ifdef _DEBUG
		Serial.println("on doit sortir de la boucle"); 
		#endif
		return true;
			
	}
	
	